require '_h2ph_pre.ph';

unless(defined(&_LINUX_JFS_H)) {
    eval 'sub _LINUX_JFS_H () {1;}' unless defined(&_LINUX_JFS_H);
    require 'asm/semaphore.ph';
    eval 'sub JFS_DEBUG () {1;}' unless defined(&JFS_DEBUG);
    if(defined(&JFS_DEBUG)) {
	eval 'sub jfs_debug () {( &n,  &f,  &a...)  &do {  &if (( &n) <=  &jfs_enable_debug) {  &printk ( &KERN_DEBUG "JFS DEBUG: (%s, %d): %s: ",  &__FILE__,  &__LINE__,  &__FUNCTION__);  &printk ( &f,   &a); } }  &while (0);}' unless defined(&jfs_debug);
    } else {
	eval 'sub jfs_debug () {( &f,  &a...);}' unless defined(&jfs_debug);
    }
    eval 'sub JFS_MIN_JOURNAL_BLOCKS () {1024;}' unless defined(&JFS_MIN_JOURNAL_BLOCKS);
    eval 'sub JFS_MAGIC_NUMBER () {0xc03b3998;}' unless defined(&JFS_MAGIC_NUMBER);
    eval 'sub JFS_DESCRIPTOR_BLOCK () {1;}' unless defined(&JFS_DESCRIPTOR_BLOCK);
    eval 'sub JFS_COMMIT_BLOCK () {2;}' unless defined(&JFS_COMMIT_BLOCK);
    eval 'sub JFS_SUPERBLOCK () {3;}' unless defined(&JFS_SUPERBLOCK);
    eval 'sub JFS_FLAG_ESCAPE () {1;}' unless defined(&JFS_FLAG_ESCAPE);
    eval 'sub JFS_FLAG_SAME_UUID () {2;}' unless defined(&JFS_FLAG_SAME_UUID);
    eval 'sub JFS_FLAG_DELETED () {4;}' unless defined(&JFS_FLAG_DELETED);
    eval 'sub JFS_FLAG_LAST_TAG () {8;}' unless defined(&JFS_FLAG_LAST_TAG);
    if(defined(&__KERNEL__)) {
	require 'linux/fs.ph';
	eval 'sub J_ASSERT {
	    local($assert) = @_;
    	    eval q( &do {  &if (!) {  &printk ( &KERN_CRIT \\"Assertion failure in %s() at %s line %d: \\" \\"\\\\\\"%s\\\\\\"\\\\n\\",  &__FUNCTION__,  &__FILE__,  &__LINE__,  $assert); * ( 0) = 0; } }  &while (0));
	}' unless defined(&J_ASSERT);
	eval("sub T_RUNNING () { 0; }") unless defined(&T_RUNNING);
	eval("sub T_LOCKED () { 1; }") unless defined(&T_LOCKED);
	eval("sub T_RUNDOWN () { 2; }") unless defined(&T_RUNDOWN);
	eval("sub T_FLUSH () { 3; }") unless defined(&T_FLUSH);
	eval("sub T_COMMIT () { 4; }") unless defined(&T_COMMIT);
	eval("sub T_FINISHED () { 5; }") unless defined(&T_FINISHED);
	eval 'sub JFS_UNMOUNT () {1;}' unless defined(&JFS_UNMOUNT);
	eval 'sub JFS_SYNC () {2;}' unless defined(&JFS_SYNC);
	eval 'sub jfs_ENOSYS () {
	    eval q( &do {  &printk ( &KERN_ERR \\"JFS unimplemented function \\"  &__FUNCTION__);  ($current->{state}) =  &TASK_UNINTERRUPTIBLE;  &schedule(); }  &while (1));
	}' unless defined(&jfs_ENOSYS);
    }
}
1;
